package fr.umlv.tatoo.cc.common.generator.impl;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Collections;
import java.util.Map;

import fr.umlv.tatoo.cc.common.generator.GeneratorException;
import fr.umlv.tatoo.cc.common.generator.TemplateEngine;
import fr.umlv.tatoo.motocity.MotoBatch;
import fr.umlv.tatoo.motocity.compiler.MemoryCompiler;

public class Motocity implements TemplateEngine {

  public void generate(Map<String, ?> map, String templateName, File output,
      File sourceDir, Class<?> clazz) throws GeneratorException {
    //FIXME Remi do you think we can do better to find tatoo jar?
    try {
      File tatooJarFile = MemoryCompiler.getPath(Motocity.class);
      MotoBatch.applyTemplate(new InputStreamReader(clazz.getResourceAsStream(templateName+".mc"),"UTF-8"),
          new PrintWriter(new OutputStreamWriter(new FileOutputStream(output),"UTF-8")), map, Collections.singleton(tatooJarFile));
    } catch (UnsupportedEncodingException e) {
      throw new GeneratorException(e);
    } catch (IOException e) {
      throw new GeneratorException(e);
    }
  }

}
