/**
 * 
 */
package fr.umlv.tatoo.cc.common.generator.impl;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.Writer;
import java.util.Map;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.runtime.RuntimeInstance;

import fr.umlv.tatoo.cc.common.generator.GeneratorException;
import fr.umlv.tatoo.cc.common.generator.TemplateEngine;
import fr.umlv.tatoo.cc.common.velocity.VelocityLogger;

public class Velocity implements TemplateEngine {
  
  private RuntimeInstance ri;

  public void generate(Map<String, ?> map, String templateName, File file, File sourceDir, Class<?> clazz)
      throws GeneratorException {
    if (ri==null || ri.getProperty("file.resource.loader.resourceClass")!=clazz) {
      try {
        ri = new RuntimeInstance();
        ri.setProperty("runtime.log.logsystem", new VelocityLogger());
        ri.setProperty("file.resource.loader.class", "fr.umlv.tatoo.cc.common.velocity.ClassResourceLoader");
        ri.setProperty("file.resource.loader.resourceClass", clazz);
        // ri.setProperty("velocimacro.library", "macros.vm");
        ri.init();
      } catch(Exception e) {
        throw new GeneratorException(e);
      }
    }
    
    VelocityContext root = new VelocityContext(map);
    
    try {
      Writer out = new BufferedWriter(new FileWriter(file));
      try {
        Template template = ri.getTemplate(templateName+".vm", "UTF-8");
        template.merge(root, out);
      } finally {
        out.close();
      }
    } catch (RuntimeException e) {
      throw e;
    } catch (Exception e) {
      throw new GeneratorException(e);
    }      
  }
  
}